%{
#include <stdio.h>
#include <stdlib.h>
#include "scan.h"
%}

%token INTCONST
%token ENDL
%left PLUS MINUS
%left MULT DIV

%start f

%%
f :             /* empty */
  | f e ENDL    { printf("=%d\n", $2.int_value); }
  ;

e : e PLUS e    {
                    $$.int_value = $1.int_value + $3.int_value;
                }
  |
e : e MINUS e   {
                    $$.int_value = $1.int_value - $3.int_value;
                }
  |
e : e MULT e    {
                    $$.int_value = $1.int_value * $3.int_value;
                }
  |
e : e DIV e     {
                    $$.int_value = $1.int_value / $3.int_value;
                }
  |
e : INTCONST    { $$.int_value = $1.int_value; }
  ;

%%

int main() {
    yyparse();
    return 0;
}

int yyerror(const char *s) {
    printf("%s\n", s); return 0;
}
