/*
 * Register definitions, etc. for Intel 80386
 * Used Assembler: "as" from GNU package
 */
#ifndef I80386_H
#define I80386_H

/* Register definitions */
#define EAX     0
#define EBX     1
#define ECX     2
#define EDX     3
#define EDI     4
#define ESI     5
#define EBP     6
#define ESP     7

#define NUM_REGISTERS           8
#define NUM_BYTE_REGISTERS      4
#define NUM_REGISTERS_ALLOCATE  6
#define REGISTER_FULL_SET       0x3f    /* bits 0..5 are set */

/* Pseudo registers */
#define MIN_PSEUDOREG   22
#define PC              16
#define SP              7
#define FP              6
#define CC0             17

/* Bits in register set */
#define EAX_BIT     1
#define EBX_BIT     2
#define ECX_BIT     4
#define EDX_BIT     8
#define EDI_BIT     16
#define ESI_BIT     32

/* Set of registers to save */
#define SAVED_REGISTERS         (EBX_BIT | EDI_BIT | ESI_BIT)
#define BYTE_REGISTERS_SET      (EAX_BIT | EBX_BIT | ECX_BIT | EDX_BIT)
#define RETURN_REGISTERS        (EAX_BIT | EDX_BIT)
#define RETURN_REGISTER         EAX

/* Label representation */
#define LABEL_PREFIX                ".L"
#define FUNCTION_CLOSE_LABEL_PREFIX ".Lfe"

#endif /* I80386_H */
