/*
 * L2-List of blocks allocated in dinamic memory
 */
#ifndef LIST_H
#define LIST_H

typedef struct block_header_tag {
    struct block_header_tag *next;
    struct block_header_tag *prev;
} block_header, *block_ptr;

void lst_link(block_ptr b1, block_ptr b2);

void lst_remove(block_ptr b);     /* remove from list */
void lst_addAfter(block_ptr pointer, block_ptr new_block);
void lst_addBefore(block_ptr pointer, block_ptr new_block);

/* Loop for every element.
   To break a loop, action(block_ptr b, void *arg1, void *arg2) must return TRUE.
   In this case, the function returns b;
   otherwise, it returns NULL */
block_ptr lst_loop(
    block_ptr header,   /* header of list, that is not in the list */
    int (*action)(block_ptr b, void *arg1, long arg2),
    void *arg1, long arg2
);

block_ptr lst_loopForward(
    block_ptr header,   /* header of list, that is not in the list */
    block_ptr start,    /* starting block */
    int (*action)(block_ptr b, void *arg1, long arg2),
    void *arg1, long arg2
);

block_ptr lst_loopReverse(
    block_ptr h,            /* header of list, that is not in the list */
    block_ptr afterStart,   /* a block after a starting block */
    int (*action)(block_ptr b, void *arg1, long arg2),
    void *arg1, long arg2
);

#endif /* LIST_H */
