#ifndef LTREE_H
#define LTREE_H

struct tree_tag;

typedef struct tree_tag {
    int type;
    struct tree_tag* left;
    struct tree_tag* right;
    char name[128];
    int int_value;
} tree;

/* Node types */
#define NAME_NODE 1
#define ICON_NODE 2
#define EXPR_NODE 3
#define LNOT_NODE 4
#define LAND_NODE 5
#define LOR_NODE  6
#define EQUOP_NODE 7
#define RELOP_NODE 8

void release_tree(tree *);
void release_node(tree *);
tree* allocate_node();
const char* node_value(tree *);

/* debug printing */
void print_tree(tree*);

#endif
